diff --git a/gdb/i386-tdep.c b/gdb/i386-tdep.c
index 560f16aa0e32..1ddca2410fdf 100644
--- a/gdb/i386-tdep.c
+++ b/gdb/i386-tdep.c
@@ -146,7 +146,7 @@ static const char * const i386_mmx_names[] =
 
 static const char * const i386_byte_names[] =
 {
-  "al", "cl", "dl", "bl", 
+  "al", "cl", "dl", "bl",
   "ah", "ch", "dh", "bh"
 };
 
@@ -389,7 +389,7 @@ i386_fpc_regnum_p (struct gdbarch *gdbarch, int regnum)
   if (I387_ST0_REGNUM (tdep) < 0)
     return 0;
 
-  return (I387_FCTRL_REGNUM (tdep) <= regnum 
+  return (I387_FCTRL_REGNUM (tdep) <= regnum
 	  && regnum < I387_XMM0_REGNUM (tdep));
 }
 
@@ -1202,7 +1202,7 @@ i386_analyze_struct_return (CORE_ADDR pc, CORE_ADDR current_pc,
       cache->pc_in_eax = 1;
       return current_pc;
     }
-  
+
   if (buf[1] == proto1[1])
     return pc + 4;
   else
@@ -1217,7 +1217,7 @@ i386_skip_probe (CORE_ADDR pc)
 	pushl constant
 	call _probe
 	addl $4, %esp
-	   
+
      followed by
 
 	pushl %ebp
@@ -1277,7 +1277,7 @@ i386_analyze_stack_align (CORE_ADDR pc, CORE_ADDR current_pc,
 		pushl -4(%reg)
 
      "andl $-XXX, %esp" can be either 3 bytes or 6 bytes:
-     
+
 	0x83 0xe4 0xf0			andl $-16, %esp
 	0x81 0xe4 0x00 0xff 0xff 0xff	andl $-256, %esp
    */
@@ -1328,7 +1328,7 @@ i386_analyze_stack_align (CORE_ADDR pc, CORE_ADDR current_pc,
       /* MOD must be binary 10 and R/M must be binary 100.  */
       if ((buf[2] & 0xc7) != 0x44)
 	return pc;
-      
+
       /* REG has register number.  Registers in pushl and leal have to
 	 be the same.  */
       if (reg != ((buf[2] >> 3) & 7))
@@ -1473,7 +1473,7 @@ i386_match_insn_block (CORE_ADDR pc, struct i386_insn *insn_patterns)
 static i386_insn i386_frame_setup_skip_insns[] =
 {
   /* Check for `movb imm8, r' and `movl imm32, r'.
-    
+
      ??? Should we handle 16-bit operand-sizes here?  */
 
   /* `movb imm8, %al' and `movb imm8, %ah' */
@@ -1548,11 +1548,11 @@ i386_skip_noop (CORE_ADDR pc)
   if (target_read_code (pc, &op, 1))
     return pc;
 
-  while (check) 
+  while (check)
     {
       check = 0;
       /* Ignore `nop' instruction.  */
-      if (op == 0x90) 
+      if (op == 0x90)
 	{
 	  pc += 1;
 	  if (target_read_code (pc, &op, 1))
@@ -1585,7 +1585,7 @@ i386_skip_noop (CORE_ADDR pc)
 	    }
 	}
     }
-  return pc; 
+  return pc;
 }
 
 /* Check whether PC points at a code that sets up a new stack frame.
@@ -1694,7 +1694,7 @@ i386_analyze_frame_setup (struct gdbarch *gdbarch,
       if (limit <= pc)
 	return limit;
 
-      /* Check for stack adjustment 
+      /* Check for stack adjustment
 
 	    subl $XXX, %esp
 	 or
@@ -1805,7 +1805,7 @@ i386_analyze_register_saves (CORE_ADDR pc, CORE_ADDR current_pc,
    %ebx (and sometimes a harmless bug causes it to also save but not
    restore %eax); however, the code below is willing to see the pushes
    in any order, and will handle up to 8 of them.
- 
+
    If the setup sequence is at the end of the function, then the next
    instruction will be a branch back to the start.  */
 
@@ -1858,7 +1858,7 @@ i386_skip_prologue (struct gdbarch *gdbarch, CORE_ADDR start_pc)
 	      || producer_is_icc_ge_19 (cust->producer ()))))
 	return std::max (start_pc, post_prologue_pc);
     }
- 
+
   cache.locals = -1;
   pc = i386_analyze_prologue (gdbarch, start_pc, 0xffffffff, &cache);
   if (cache.locals < 0)
@@ -2369,7 +2369,7 @@ static const struct frame_unwind i386_epilogue_frame_unwind =
   i386_epilogue_frame_unwind_stop_reason,
   i386_epilogue_frame_this_id,
   i386_epilogue_frame_prev_register,
-  NULL, 
+  NULL,
   i386_epilogue_frame_sniffer
 };
 
@@ -2451,7 +2451,7 @@ static const struct frame_unwind i386_stack_tramp_frame_unwind =
   i386_epilogue_frame_unwind_stop_reason,
   i386_epilogue_frame_this_id,
   i386_epilogue_frame_prev_register,
-  NULL, 
+  NULL,
   i386_stack_tramp_frame_sniffer
 };
 
@@ -4710,7 +4710,7 @@ i386_register_reggroup_p (struct gdbarch *gdbarch, int regnum,
 /* Get the ARGIth function argument for the current function.  */
 
 static CORE_ADDR
-i386_fetch_pointer_argument (frame_info_ptr frame, int argi, 
+i386_fetch_pointer_argument (frame_info_ptr frame, int argi,
 			     struct type *type)
 {
   struct gdbarch *gdbarch = get_frame_arch (frame);
@@ -5690,7 +5690,7 @@ i386_process_record (struct gdbarch *gdbarch, struct regcache *regcache,
 	  ir.addr -= 1;
 	  goto no_support;
 	}
-      for (regnum = X86_RECORD_REAX_REGNUM; 
+      for (regnum = X86_RECORD_REAX_REGNUM;
 	   regnum <= X86_RECORD_REDI_REGNUM;
 	   regnum++)
 	I386_RECORD_FULL_ARCH_LIST_ADD_REG (regnum);
diff --git a/gdb/i386-tdep.h b/gdb/i386-tdep.h
index 34dc53db8d93..4283a52c9292 100644
--- a/gdb/i386-tdep.h
+++ b/gdb/i386-tdep.h
@@ -295,7 +295,7 @@ enum i386_regnum
   I386_FS_REGNUM,		/* %fs */
   I386_GS_REGNUM,		/* %gs */
   I386_ST0_REGNUM,		/* %st(0) */
-  I386_MXCSR_REGNUM = 40,	/* %mxcsr */ 
+  I386_MXCSR_REGNUM = 40,	/* %mxcsr */
   I386_YMM0H_REGNUM,		/* %ymm0h */
   I386_YMM7H_REGNUM = I386_YMM0H_REGNUM + 7,
   I386_BND0R_REGNUM,