diff --git a/gdb/corefile.c b/gdb/corefile.c
index 19a96bc6f86..b9c204d18dc 100644
--- a/gdb/corefile.c
+++ b/gdb/corefile.c
@@ -105,21 +105,24 @@ specify_exec_file_hook (void (*hook) (const char *))
 void
 reopen_exec_file (void)
 {
-  int res;
-  struct stat st;
+  bfd *exec_bfd = current_program_space->exec_bfd ();
 
   /* Don't do anything if there isn't an exec file.  */
-  if (current_program_space->exec_bfd () == NULL)
+  if (exec_bfd == nullptr)
     return;
 
+  /* The main executable can't be an in-memory BFD object.  If it was then
+     the use of bfd_stat below would not work as expected.  */
+  gdb_assert ((exec_bfd->flags & BFD_IN_MEMORY) == 0);
+
   /* If the timestamp of the exec file has changed, reopen it.  */
-  std::string filename = bfd_get_filename (current_program_space->exec_bfd ());
-  res = stat (filename.c_str (), &st);
+  struct stat st;
+  int res = bfd_stat (exec_bfd, &st);
 
   if (res == 0
-      && current_program_space->ebfd_mtime
+      && current_program_space->ebfd_mtime != 0
       && current_program_space->ebfd_mtime != st.st_mtime)
-    exec_file_attach (filename.c_str (), 0);
+    exec_file_attach (bfd_get_filename (exec_bfd), 0);
 }
 
 /* If we have both a core file and an exec file,
diff --git a/gdb/testsuite/gdb.server/target-exec-file.exp b/gdb/testsuite/gdb.server/target-exec-file.exp
index 9260df8b88d..40863538785 100644
--- a/gdb/testsuite/gdb.server/target-exec-file.exp
+++ b/gdb/testsuite/gdb.server/target-exec-file.exp
@@ -52,6 +52,19 @@ set target_exec [gdb_remote_download target $binfile]
 # prompt us if this is the right thing to do.
 gdb_test_no_output "set confirm off"
 
+if { [allow_python_tests] } {
+    # Register an event handler for the executable changed event.
+    # This handler just copies the event into a global Python object.
+    gdb_test_multiline "Add connection_removed event" \
+	"python" "" \
+	"global_exec_changed_event = None" "" \
+	"def executable_changed(event):" "" \
+	"   global global_exec_changed_event" "" \
+	"   global_exec_changed_event = event" "" \
+	"gdb.events.executable_changed.connect (executable_changed)" "" \
+	"end" ""
+}
+
 # Start gdbserver, but always in extended-remote mode, and then
 # connect to it from GDB.
 set res [gdbserver_start "--multi" $target_exec]
@@ -59,6 +72,22 @@ set gdbserver_protocol "extended-remote"
 set gdbserver_gdbport [lindex $res 1]
 gdb_target_cmd $gdbserver_protocol $gdbserver_gdbport
 
+if { [allow_python_tests] } {
+    # When connecting to a remote target, if the user has not told GDB
+    # which executable to use, then GDB will figure out an executable
+    # from the remote target.
+    #
+    # As a result we expect to have seen an executable changed event.
+    with_test_prefix "after connecting" {
+	gdb_test "python print(global_exec_changed_event)" \
+	    "<gdb.ExecutableChangedEvent object at $hex>"
+	gdb_test "python print(global_exec_changed_event.progspace.executable_filename)" \
+	    [string_to_regexp target:$target_exec]
+	gdb_test "python print(global_exec_changed_event.reload)" "False"
+	gdb_test_no_output "python global_exec_changed_event = None"
+    }
+}
+
 # Issue a 'file' command and parse the output.  We look for a couple
 # of specific things to ensure that we are correctly reading the exec
 # from the remote target.
@@ -104,6 +133,20 @@ gdb_assert { $saw_read_of_remote_exec } \
 gdb_assert { $saw_read_of_syms_from_exec } \
     "symbols were read from remote exec file"
 
+if { [allow_python_tests] } {
+    # The 'file' command forces GDB to always load the executable,
+    # even if the same filename is used.  In this case, as the
+    # filename is the same, this will show as a reload event.
+    with_test_prefix "after 'file' command" {
+	gdb_test "python print(global_exec_changed_event)" \
+	    "<gdb.ExecutableChangedEvent object at $hex>"
+	gdb_test "python print(global_exec_changed_event.progspace.executable_filename)" \
+	    [string_to_regexp target:$target_exec]
+	gdb_test "python print(global_exec_changed_event.reload)" "True"
+	gdb_test_no_output "python global_exec_changed_event = None"
+    }
+}
+
 # Start the inferior (with the 'start' command), use TESTNAME for any
 # pass/fail calls.  EXPECT_REREAD should be true or false and
 # indicates if we expect to too a line like:
@@ -155,10 +198,24 @@ proc start_inferior { testname expect_reread } {
 # see the symbols re-read now.
 start_inferior "start inferior the first time" false
 
+if { [allow_python_tests] } {
+    # The executable hasn't changed.
+    with_test_prefix "after starting inferior for the first time" {
+	gdb_test "python print(global_exec_changed_event)" "None"
+    }
+}
+
 # Re-start the inferior.  The executable is unchanged so we should not
 # see the symbol file being re-read.
 start_inferior "start inferior a second time" false
 
+if { [allow_python_tests] } {
+    # The executable still hasn't changed.
+    with_test_prefix "after starting inferior for the second time" {
+	gdb_test "python print(global_exec_changed_event)" "None"
+    }
+}
+
 # Delay for a short while so, when we touch the exec, we know the
 # timestamp will change.
 sleep 1
@@ -172,3 +229,16 @@ if { $status != 0 } {
 # Start the inferior again, we expect to see the symbols being re-read
 # from the remote file.
 start_inferior "start inferior a third time" true
+
+if { [allow_python_tests] } {
+    # The executable has now changed on disk.  This will be a reload
+    # event.
+    with_test_prefix "after starting inferior for the third time" {
+	gdb_test "python print(global_exec_changed_event)" \
+	    "<gdb.ExecutableChangedEvent object at $hex>"
+	gdb_test "python print(global_exec_changed_event.progspace.executable_filename)" \
+	    [string_to_regexp target:$target_exec]
+	gdb_test "python print(global_exec_changed_event.reload)" "True"
+	gdb_test_no_output "python global_exec_changed_event = None"
+    }
+}